% Copyright Pieter Abbeel
%
% 3.9 Global Localization with Likelihood Field
%
% tic; p3_9_global_localization_w_likelihood_field; toc
% Elapsed time is 50.587997 seconds.
% -- this was for: loops_world_path1, 2000 particles
% Setting I used: 2000 particles, stratified resampling, softened weight
% updates (^0.01), and varying the number of uniformly at random sampled
% particles as (9+t)/(10+t) --- initially lots of uniformly at random
% resampling, less so as time goes along
%

clear; clc; close all;

%load good_world;

%load simple_world_path1;
%load simple_world_path2;
%load rooms_world_path1;
%load rooms_world_path2;
load loops_world_path1;
%load loops_world_path2;


T = size(z,2);

%% visualize true path

figure; axis equal; hold on;
draw_gridworld(gridworld);
if(exist('x'))
	plot(x(1,:), x(2,:), 'x-');
end

[m,n] = size(gridworld);



%% lf:
lf_xy_res = [0.25; 0.25]; %[0.25; 0.25];
p_hit = 0.95;
p_uniform = 0.05;
z_max = 20;
sigma = laser_model.sigma_hit*10; %to make it a bit smoother
lf = likelihood_field_from_gridworld(gridworld, lf_xy_res, sigma, p_hit, p_uniform, z_max);
%figure; axis equal; hold on; draw_likelihood_field(lf, lf_xy_res);


%% run particle filter for localization

% YOUR code here


% you are likely going to want a function of the following form:
%  weight_updates = likelihood_field_measurement_probability_gridworld_batch(particles, weights, z{t}, laser_model, lf, lf_xy_res);
%  
% Key components:
% 1. Interpolation:
% Also: a reasonable way to interpolate is bilinear interpolation: for a
% function taken on values f00 = f(x0, y0), f01 = f(x0, y1), f10 = f(x1,
% y0), f11 = f(x1, y1)
% the bilinear interpolation finds f(x,y) for x \in [x0, x1], and y \in
% [y0, y1] as:
%   f00*(1-p)(1-q) + f10*p*(1-q) + f01*(1-p)*q + f11*p*q
% where: p = (x-x0)/(x1-x0); q = (y-y0)/(y1-y0);
%
% 2. Vectorization of its implementation. For me vectorizing (instead of
% for-looping over particles resulted in 300-fold speed-up for 1000
% particles (and even more for more particles).
%


